/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.40 from the
 * contents of X509.xs. Do not edit this file, edit X509.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "X509.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <openssl/asn1.h>
#include <openssl/objects.h>
#include <openssl/bio.h>
#include <openssl/crypto.h>
#include <openssl/err.h>
#include <openssl/evp.h>
#include <openssl/pem.h>
#include <openssl/x509.h>
#include <openssl/x509v3.h>
#include <openssl/opensslconf.h>
#ifndef OPENSSL_NO_EC
# include <openssl/ec.h>
#endif

/* from openssl/apps/apps.h */
#define FORMAT_UNDEF    0
#define FORMAT_ASN1     1
#define FORMAT_TEXT     2
#define FORMAT_PEM      3
#define FORMAT_PKCS12   5
#define FORMAT_SMIME    6
#define FORMAT_ENGINE   7
#define FORMAT_IISSGC   8

/* fake our package name */
typedef X509*  Crypt__OpenSSL__X509;
typedef X509_EXTENSION* Crypt__OpenSSL__X509__Extension;
typedef ASN1_OBJECT* Crypt__OpenSSL__X509__ObjectID;
typedef X509_NAME* Crypt__OpenSSL__X509__Name;
typedef X509_NAME_ENTRY* Crypt__OpenSSL__X509__Name_Entry;
typedef X509_CRL* Crypt__OpenSSL__X509__CRL;

/* 1.0 backwards compat */
#if OPENSSL_VERSION_NUMBER < 0x10100000
#define const_ossl11

#ifndef sk_OPENSSL_STRING_num
#define sk_OPENSSL_STRING_num sk_num
#endif

#ifndef sk_OPENSSL_STRING_value
#define sk_OPENSSL_STRING_value sk_value
#endif

static ASN1_INTEGER *X509_get0_serialNumber(const X509 *a)
{
  return a->cert_info->serialNumber;
}

static void RSA_get0_key(const RSA *r,
                         const BIGNUM **n, const BIGNUM **e, const BIGNUM **d)
{
  if (n != NULL)
    *n = r->n;
  if (e != NULL)
    *e = r->e;
  if (d != NULL)
    *d = r->d;
}

static RSA *EVP_PKEY_get0_RSA(EVP_PKEY *pkey)
{
  if (pkey->type != EVP_PKEY_RSA)
    return NULL;
  return pkey->pkey.rsa;
}

static void X509_CRL_get0_signature(const X509_CRL *crl, const ASN1_BIT_STRING **psig,
                                    X509_ALGOR **palg)
{
  if (psig != NULL)
    *psig = crl->signature;
  if (palg != NULL)
    *palg = crl->sig_alg;
}

#if OPENSSL_VERSION_NUMBER < 0x10002000
static void X509_get0_signature(const_ossl11 ASN1_BIT_STRING **psig, const_ossl11 X509_ALGOR **palg,
                                const X509 *x)
{
    if (psig != NULL)
        *psig = x->signature;
    if (palg != NULL)
        *palg = x->sig_alg;
}
#endif

static void DSA_get0_pqg(const DSA *d,
                         const BIGNUM **p, const BIGNUM **q, const BIGNUM **g)
{
  if (p != NULL)
    *p = d->p;
  if (q != NULL)
    *q = d->q;
  if (g != NULL)
    *g = d->g;
}

static void DSA_get0_key(const DSA *d,
                         const BIGNUM **pub_key, const BIGNUM **priv_key)
{
  if (pub_key != NULL)
    *pub_key = d->pub_key;
  if (priv_key != NULL)
    *priv_key = d->priv_key;
}

static DSA *EVP_PKEY_get0_DSA(EVP_PKEY *pkey)
{
  if (pkey->type != EVP_PKEY_DSA)
    return NULL;
  return pkey->pkey.dsa;
}

static EC_KEY *EVP_PKEY_get0_EC_KEY(EVP_PKEY *pkey)
{
  if (pkey->type != EVP_PKEY_EC)
    return NULL;
  return pkey->pkey.ec;
}

#else
#define const_ossl11 const
#endif

/* Unicode 0xfffd */
static U8 utf8_substitute_char[3] = { 0xef, 0xbf, 0xbd };

/* stolen from OpenSSL.xs */
long bio_write_cb(struct bio_st *bm, int m, const char *ptr, int l, long x, long y) {

  if (m == BIO_CB_WRITE) {
    SV *sv = (SV *) BIO_get_callback_arg(bm);
    sv_catpvn(sv, ptr, l);
  }

  if (m == BIO_CB_PUTS) {
    SV *sv = (SV *) BIO_get_callback_arg(bm);
    l = strlen(ptr);
    sv_catpvn(sv, ptr, l);
  }

  return l;
}

static BIO* sv_bio_create(void) {

  SV *sv = newSVpvn("", 0);

  /* create an in-memory BIO abstraction and callbacks */
  BIO *bio = BIO_new(BIO_s_mem());

  BIO_set_callback(bio, bio_write_cb);
  BIO_set_callback_arg(bio, (void *)sv);

  return bio;
}

static SV* sv_bio_final(BIO *bio) {

  SV* sv;

  (void)BIO_flush(bio);
  sv = (SV *)BIO_get_callback_arg(bio);
  BIO_set_callback_arg(bio, (void *)NULL);
  BIO_set_callback(bio, (void *)NULL);
  BIO_free_all(bio);

  if (!sv) sv = &PL_sv_undef;

  return sv;
}

/* call this just before sv_bio_final if the BIO got an UTF8 encoded text and you want native perl utf-8 strings. */
static SV* sv_bio_utf8_on(BIO *bio) {

  SV* sv = (SV *)BIO_get_callback_arg(bio);

  /* Illegal utf-8 in the string */
  if (!sv_utf8_decode(sv)) {
    STRLEN len;
    SV *nsv = newSVpvn("", 0);

    const U8* start = (U8 *) SvPV(sv, len);
    const U8* end   = start + len;
    const U8* cur;

    while ((start < end) && !is_utf8_string_loclen(start, len, &cur, 0)) {
      sv_catpvn(nsv, (const char*)start, (cur - start) + 1);  /* text that was ok */
      sv_catpvn(nsv, (const char*)utf8_substitute_char, 3);  /* insert \x{fffd} */
      start = cur + 1;
      len = end - cur;
    }

    if (start < end) {
      sv_catpvn(nsv, (const char*)start, (cur - start) - 1);  /* rest of the string */
    }

    sv_copypv(sv, nsv);
    SvREFCNT_dec(nsv);
    sv_utf8_decode(sv); /* should be ok now */
  }

  return sv;
}

/*
static void sv_bio_error(BIO *bio) {

  SV* sv = (SV *)BIO_get_callback_arg(bio);
  if (sv) sv_free(sv);

  BIO_free_all (bio);
}
*/

static const char *ssl_error(void) {
  BIO *bio;
  SV *sv;
  STRLEN l;

  bio = sv_bio_create();
  ERR_print_errors(bio);
  sv = sv_bio_final(bio);
  ERR_clear_error();
  return SvPV(sv, l);
}

// Make a scalar ref to a class object
static SV* sv_make_ref(const char* class, void* object) {
  SV* rv;

  rv = newSV(0);
  sv_setref_pv(rv, class, (void*) object);

  if (! sv_isa(rv, class) ) {
    croak("Error creating reference to %s", class);
  }

  return rv;
}

/*
 * hash of extensions from x509.
 * no_name can be
 *  0: index by long name,
 *  1: index by oid string,
 *  2: index by short name
*/
static HV* hv_exts(X509* x509, int no_name) {
  X509_EXTENSION *ext;
  int i, c, r;
  size_t len = 128;
  char* key = NULL;
  SV* rv;

  HV* RETVAL = newHV();
  sv_2mortal((SV*)RETVAL);
  c = X509_get_ext_count(x509);

  if ( !(c > 0) ) {
    croak("No extensions found\n");
  }

  for (i = 0; i < c; i++) {
    r = 0;

    ext = X509_get_ext(x509, i);

    if (ext == NULL) croak("Extension %d unavailable\n", i);

    rv = sv_make_ref("Crypt::OpenSSL::X509::Extension", (void*)ext);

    if (no_name == 0 || no_name == 1) {

       key = malloc(sizeof(char) * (len + 1)); /*FIXME will it leak?*/
       r = OBJ_obj2txt(key, len, X509_EXTENSION_get_object(ext), no_name);

    } else if (no_name == 2) {

       key = (char*)OBJ_nid2sn(OBJ_obj2nid(X509_EXTENSION_get_object(ext)));
       r = strlen(key);
    }

    if (! hv_store(RETVAL, key, r, rv, 0) ) croak("Error storing extension in hash\n");
  }

  return RETVAL;
}

#line 305 "X509.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 449 "X509.c"

XS_EUPXS(XS_Crypt__OpenSSL__X509_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "class");
    {
	SV *	class = ST(0)
;
	Crypt__OpenSSL__X509	RETVAL;
#line 336 "X509.xs"
  if ((RETVAL = X509_new()) == NULL) {
    croak("X509_new");
  }

  if (!X509_set_version(RETVAL, 2)) {
    X509_free(RETVAL);
    croak ("%s - can't X509_set_version()", SvPV_nolen(class));
  }

  ASN1_INTEGER_set(X509_get_serialNumber(RETVAL), 0L);

#line 473 "X509.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::OpenSSL::X509", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509_new_from_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509_new_from_string)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "class, string, format = FORMAT_PEM");
    {
	SV *	class = ST(0)
;
	SV *	string = ST(1)
;
	int	format;
#line 360 "X509.xs"
  BIO *bio;
  STRLEN len;
  char *cert;

#line 503 "X509.c"
	Crypt__OpenSSL__X509	RETVAL;

	if (items < 3)
	    format = FORMAT_PEM;
	else {
	    format = (int)SvIV(ST(2))
;
	}
#line 366 "X509.xs"
  cert = SvPV(string, len);

  if (ix == 1) {
    bio = BIO_new_file(cert, "r");
  } else {
    bio = BIO_new_mem_buf(cert, len);
  }

  if (!bio) croak("%s: Failed to create BIO", SvPV_nolen(class));

  /* this can come in any number of ways */
  if (format == FORMAT_ASN1) {

    RETVAL = (X509*)d2i_X509_bio(bio, NULL);

  } else {

    RETVAL = (X509*)PEM_read_bio_X509(bio, NULL, NULL, NULL);
  }

  BIO_free_all(bio);

  if (!RETVAL) croak("%s: failed to read X509 certificate.", SvPV_nolen(class));

#line 537 "X509.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::OpenSSL::X509", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x509");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__OpenSSL__X509	x509;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Crypt::OpenSSL::X509::DESTROY",
			"x509")
;
#line 399 "X509.xs"
  if (x509) X509_free(x509); x509 = 0;
#line 571 "X509.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__OpenSSL__X509___X509_cleanup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509___X509_cleanup)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "void");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 406 "X509.xs"
  CRYPTO_cleanup_all_ex_data();
  ERR_free_strings();
#if OPENSSL_VERSION_NUMBER < 0x10100000
  ERR_remove_state(0);
#endif
  EVP_cleanup();
#line 594 "X509.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__OpenSSL__X509_accessor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509_accessor)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "x509");
    {
	Crypt__OpenSSL__X509	x509;
#line 432 "X509.xs"
  BIO *bio;
  X509_NAME *name;

#line 614 "X509.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"x509", "Crypt::OpenSSL::X509")
;
#line 437 "X509.xs"
  bio = sv_bio_create();

  /* this includes both subject and issuer since they are so much alike */
  if (ix == 1 || ix == 2) {

    if (ix == 1) {
      name = X509_get_subject_name(x509);
    } else {
      name = X509_get_issuer_name(x509);
    }

    /* this is prefered over X509_NAME_oneline() */
    X509_NAME_print_ex(bio, name, 0, (XN_FLAG_SEP_CPLUS_SPC | ASN1_STRFLGS_UTF8_CONVERT) & ~ASN1_STRFLGS_ESC_MSB);

    /* this need not be pure ascii, try to get a native perl character string with * utf8 */
    sv_bio_utf8_on(bio);

  } else if (ix == 3) {

    i2a_ASN1_INTEGER(bio, X509_get0_serialNumber(x509));

  } else if (ix == 4) {

    BIO_printf(bio, "%08lx", X509_subject_name_hash(x509));

  } else if (ix == 5) {

    ASN1_TIME_print(bio, X509_get_notBefore(x509));

  } else if (ix == 6) {

    ASN1_TIME_print(bio, X509_get_notAfter(x509));

  } else if (ix == 7) {

    int j;
    STACK_OF(OPENSSL_STRING) *emlst = X509_get1_email(x509);

    for (j = 0; j < sk_OPENSSL_STRING_num(emlst); j++) {
      BIO_printf(bio, "%s", sk_OPENSSL_STRING_value(emlst, j));
    }

    X509_email_free(emlst);

  } else if (ix == 8) {

    BIO_printf(bio, "%02ld", X509_get_version(x509));

  } else if (ix == 9) {
    const_ossl11 X509_ALGOR *palg;
    const_ossl11 ASN1_OBJECT *paobj;

    X509_get0_signature(NULL, &palg, x509);
    X509_ALGOR_get0(&paobj, NULL, NULL, palg);

    i2a_ASN1_OBJECT(bio, paobj);
  } else if ( ix == 10 ) {
    X509_PUBKEY *pkey;
    ASN1_OBJECT *ppkalg;

    pkey = X509_get_X509_PUBKEY(x509);
    X509_PUBKEY_get0_param(&ppkalg, NULL, NULL, NULL, pkey);

    i2a_ASN1_OBJECT(bio, ppkalg);
  } else if ( ix == 11 ) {
    BIO_printf(bio, "%08lx", X509_issuer_name_hash(x509));
  }

  RETVAL = sv_bio_final(bio);

#line 697 "X509.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509_subject_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509_subject_name)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "x509");
    {
	Crypt__OpenSSL__X509	x509;
	Crypt__OpenSSL__X509__Name	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"x509", "Crypt::OpenSSL::X509")
;
#line 519 "X509.xs"
  if (ix == 1) {
    RETVAL = X509_get_subject_name(x509);
  } else {
    RETVAL = X509_get_issuer_name(x509);
  }

#line 732 "X509.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::OpenSSL::X509::Name", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509_sig_print); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509_sig_print)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x509");
    {
	Crypt__OpenSSL__X509	x509;
#line 533 "X509.xs"
  BIO *bio;
  unsigned char *s;
  const_ossl11 ASN1_BIT_STRING *psig;
  int n,i;

#line 758 "X509.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::sig_print",
			"x509", "Crypt::OpenSSL::X509")
;
#line 540 "X509.xs"
  X509_get0_signature(&psig, NULL, x509);
  n   = psig->length;
  s   = psig->data;
  bio = sv_bio_create();

  for (i=0; i<n; i++) {
    BIO_printf(bio, "%02x", s[i]);
  }

  RETVAL = sv_bio_final(bio);
#line 781 "X509.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509_as_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509_as_string)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "x509, format = FORMAT_PEM");
    {
	Crypt__OpenSSL__X509	x509;
	int	format;
#line 559 "X509.xs"
  BIO *bio;

#line 801 "X509.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::as_string",
			"x509", "Crypt::OpenSSL::X509")
;

	if (items < 2)
	    format = FORMAT_PEM;
	else {
	    format = (int)SvIV(ST(1))
;
	}
#line 563 "X509.xs"
  bio = sv_bio_create();

  /* get the certificate back out in a specified format. */

  if (format == FORMAT_PEM) {

    PEM_write_bio_X509(bio, x509);

  } else if (format == FORMAT_ASN1) {

    i2d_X509_bio(bio, x509);

  }

  RETVAL = sv_bio_final(bio);

#line 837 "X509.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509_bit_length); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509_bit_length)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x509");
    {
	Crypt__OpenSSL__X509	x509;
#line 587 "X509.xs"
  EVP_PKEY *pkey;
  DSA *dsa_pkey;
  RSA *rsa_pkey;
  EC_KEY *ec_pkey;
  const BIGNUM *p;
  const BIGNUM *n;
  int length;

#line 862 "X509.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::bit_length",
			"x509", "Crypt::OpenSSL::X509")
;
#line 596 "X509.xs"
  pkey = X509_extract_key(x509);
  if (pkey == NULL) {
    EVP_PKEY_free(pkey);
    croak("Public key is unavailable\n");
  }

  switch(EVP_PKEY_base_id(pkey)) {
    case EVP_PKEY_RSA:
      rsa_pkey = EVP_PKEY_get0_RSA(pkey);
      RSA_get0_key(rsa_pkey, &n, NULL, NULL);
      length = BN_num_bits(n);
      break;
    case EVP_PKEY_DSA:
      dsa_pkey = EVP_PKEY_get0_DSA(pkey);
      DSA_get0_pqg(dsa_pkey, &p, NULL, NULL);
      length = BN_num_bits(p);
      break;
#ifndef OPENSSL_NO_EC
    case EVP_PKEY_EC:
    {
      const EC_GROUP *group;
      BIGNUM* ec_order;
      ec_order = BN_new();
      if ( !ec_order ) {
        EVP_PKEY_free(pkey);
        croak("Could not malloc bignum");
      }
      ec_pkey = EVP_PKEY_get0_EC_KEY(pkey);
      if ( (group = EC_KEY_get0_group(ec_pkey)) == NULL) {
        EVP_PKEY_free(pkey);
        croak("No EC group");
      }
      //
      if (!EC_GROUP_get_order(group, ec_order, NULL)) {
        EVP_PKEY_free(pkey);
        croak("Could not get ec-group order");
      }
      length = BN_num_bits(ec_order);
      //
      BN_free(ec_order);
      break;
    }
#endif
    default:
      EVP_PKEY_free(pkey);
      croak("Unknown public key type");
  }

  RETVAL = newSVuv(length);

#line 925 "X509.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509_curve); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509_curve)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x509");
    {
	Crypt__OpenSSL__X509	x509;
#line 654 "X509.xs"
#ifndef OPENSSL_NO_EC
  EVP_PKEY *pkey;
#endif

#line 946 "X509.c"
	const char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::curve",
			"x509", "Crypt::OpenSSL::X509")
;
#line 659 "X509.xs"
#ifdef OPENSSL_NO_EC
  if ( x509 ) {} // fix unused variable warning.
  croak("OpenSSL without EC-support");
#else
  pkey = X509_extract_key(x509);
  if (pkey == NULL) {
    EVP_PKEY_free(pkey);
    croak("Public key is unavailable\n");
  }
  if ( EVP_PKEY_base_id(pkey) == EVP_PKEY_EC ) {
    const EC_GROUP *group;
    EC_KEY *ec_pkey;
    int nid;
    ec_pkey = EVP_PKEY_get0_EC_KEY(pkey);
    if ( (group = EC_KEY_get0_group(ec_pkey)) == NULL) {
       EVP_PKEY_free(pkey);
       croak("No EC group");
    }
    nid = EC_GROUP_get_curve_name(group);
    if ( nid == 0 ) {
       EVP_PKEY_free(pkey);
       croak("invalid nid");
    }
    RETVAL = OBJ_nid2sn(nid);
  } else {
    EVP_PKEY_free(pkey);
    croak("Wrong Algorithm type\n");
  }
  EVP_PKEY_free(pkey);
#endif

#line 991 "X509.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509_modulus); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509_modulus)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x509");
    {
	Crypt__OpenSSL__X509	x509;
#line 699 "X509.xs"
  EVP_PKEY *pkey;
  BIO *bio;
  int pkey_id;

#line 1011 "X509.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::modulus",
			"x509", "Crypt::OpenSSL::X509")
;
#line 705 "X509.xs"
  pkey = X509_extract_key(x509);
  bio  = sv_bio_create();

  if (pkey == NULL) {

    BIO_free_all(bio);
    EVP_PKEY_free(pkey);
    croak("Modulus is unavailable\n");
  }

  pkey_id = EVP_PKEY_base_id(pkey);
  if (pkey_id == EVP_PKEY_RSA) {
    RSA *rsa_pkey;
    const BIGNUM *n;

    rsa_pkey = EVP_PKEY_get0_RSA(pkey);
    RSA_get0_key(rsa_pkey, &n, NULL, NULL);

    BN_print(bio, n);

  } else if (pkey_id == EVP_PKEY_DSA) {
    DSA *dsa_pkey;
    const BIGNUM *pub_key;

    dsa_pkey = EVP_PKEY_get0_DSA(pkey);
    DSA_get0_key(dsa_pkey, &pub_key, NULL);
    BN_print(bio, pub_key);
#ifndef OPENSSL_NO_EC
  } else if ( pkey_id == EVP_PKEY_EC ) {
    const EC_POINT *public_key;
    const EC_GROUP *group;
    EC_KEY *ec_pkey;
    BIGNUM  *pub_key=NULL;

    ec_pkey = EVP_PKEY_get0_EC_KEY(pkey);
    if ( (group = EC_KEY_get0_group(ec_pkey)) == NULL) {
       BIO_free_all(bio);
       EVP_PKEY_free(pkey);
       croak("No EC group");
    }
    public_key = EC_KEY_get0_public_key(ec_pkey);
    if ((pub_key = EC_POINT_point2bn(group, public_key, EC_KEY_get_conv_form(ec_pkey), NULL, NULL)) == NULL) {
       BIO_free_all(bio);
       EVP_PKEY_free(pkey);
       croak("EC library error");
    }
    BN_print(bio, pub_key);
#endif
  } else {

    BIO_free_all(bio);
    EVP_PKEY_free(pkey);
    croak("Wrong Algorithm type\n");
  }

  RETVAL = sv_bio_final(bio);

  EVP_PKEY_free(pkey);

#line 1083 "X509.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509_exponent); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509_exponent)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "x509");
    {
	Crypt__OpenSSL__X509	x509;
#line 772 "X509.xs"
  EVP_PKEY *pkey;
  BIO *bio;

#line 1104 "X509.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"x509", "Crypt::OpenSSL::X509")
;
#line 779 "X509.xs"
  pkey = X509_get_pubkey(x509);
  bio  = sv_bio_create();

  /* Silence warning */
  if (ix)

  if (pkey == NULL) {
    BIO_free_all(bio);
    EVP_PKEY_free(pkey);
    croak("Exponent is unavailable\n");
  }

  if (EVP_PKEY_base_id(pkey) == EVP_PKEY_RSA) {
    RSA *rsa_pkey;
    const BIGNUM *e;

    rsa_pkey = EVP_PKEY_get0_RSA(pkey);
    RSA_get0_key(rsa_pkey, NULL, &e, NULL);

    BN_print(bio, e);
  } else {
    BIO_free_all(bio);
    EVP_PKEY_free(pkey);
    croak("Wrong Algorithm type -- exponent only available with RSA\n");
  }

  RETVAL = sv_bio_final(bio);

  EVP_PKEY_free(pkey);

#line 1147 "X509.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509_fingerprint_md5); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509_fingerprint_md5)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "x509");
    {
	Crypt__OpenSSL__X509	x509;
#line 825 "X509.xs"
  const EVP_MD *mds[] = { EVP_md5(), EVP_sha1(), EVP_sha224(), EVP_sha256(), EVP_sha384(), EVP_sha512() };
  unsigned char md[EVP_MAX_MD_SIZE];
  int i;
  unsigned int n;
  BIO *bio;

#line 1171 "X509.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"x509", "Crypt::OpenSSL::X509")
;
#line 833 "X509.xs"
  bio = sv_bio_create();

  if (!X509_digest(x509, mds[ix], md, &n)) {

    BIO_free_all(bio);
    croak("Digest error: %s", ssl_error());
  }

  BIO_printf(bio, "%02X", md[0]);
  for (i = 1; i < n; i++) {
    BIO_printf(bio, ":%02X", md[i]);
  }

  RETVAL = sv_bio_final(bio);

#line 1199 "X509.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509_checkend); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509_checkend)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "x509, checkoffset");
    {
	Crypt__OpenSSL__X509	x509;
	IV	checkoffset = (IV)SvIV(ST(1))
;
#line 857 "X509.xs"
  time_t now;

#line 1220 "X509.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::checkend",
			"x509", "Crypt::OpenSSL::X509")
;
#line 861 "X509.xs"
  now = time(NULL);

  /* given an offset in seconds, will the certificate be expired? */
  if (ASN1_UTCTIME_cmp_time_t(X509_get_notAfter(x509), now + (int)checkoffset) == -1) {
    RETVAL = &PL_sv_yes;
  } else {
    RETVAL = &PL_sv_no;
  }

#line 1242 "X509.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509_pubkey); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509_pubkey)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x509");
    {
	Crypt__OpenSSL__X509	x509;
#line 878 "X509.xs"
  EVP_PKEY *pkey;
  BIO *bio;
  int pkey_id;

#line 1263 "X509.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::pubkey",
			"x509", "Crypt::OpenSSL::X509")
;
#line 884 "X509.xs"
  pkey = X509_get_pubkey(x509);
  bio  = sv_bio_create();

  if (pkey == NULL) {

    BIO_free_all(bio);
    EVP_PKEY_free(pkey);
    croak("Public Key is unavailable\n");
  }

  pkey_id = EVP_PKEY_base_id(pkey);
  if (pkey_id == EVP_PKEY_RSA) {
    RSA *rsa_pkey;

    rsa_pkey = EVP_PKEY_get0_RSA(pkey);
    PEM_write_bio_RSAPublicKey(bio, rsa_pkey);

  } else if (pkey_id == EVP_PKEY_DSA) {
    DSA *dsa_pkey;

    dsa_pkey = EVP_PKEY_get0_DSA(pkey);

    PEM_write_bio_DSA_PUBKEY(bio, dsa_pkey);
#ifndef OPENSSL_NO_EC
  } else if (pkey_id == EVP_PKEY_EC ) {
    EC_KEY *ec_pkey;

    ec_pkey = EVP_PKEY_get0_EC_KEY(pkey);
    PEM_write_bio_EC_PUBKEY(bio, ec_pkey);
#endif
  } else {

    BIO_free_all(bio);
    EVP_PKEY_free(pkey);
    croak("Wrong Algorithm type\n");
  }

  EVP_PKEY_free(pkey);

  RETVAL = sv_bio_final(bio);

#line 1317 "X509.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509_pubkey_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509_pubkey_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x509");
    {
	Crypt__OpenSSL__X509	x509;
#line 932 "X509.xs"
        EVP_PKEY *pkey;
	int pkey_id;
#line 1336 "X509.c"
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::pubkey_type",
			"x509", "Crypt::OpenSSL::X509")
;
#line 935 "X509.xs"
        RETVAL=NULL;
        pkey = X509_get_pubkey(x509);

        if(!pkey)
            XSRETURN_UNDEF;

	pkey_id = EVP_PKEY_base_id(pkey);
        if (pkey_id == EVP_PKEY_DSA) {
            RETVAL="dsa";

        } else if (pkey_id == EVP_PKEY_RSA) {
            RETVAL="rsa";
#ifndef OPENSSL_NO_EC
        } else if (pkey_id == EVP_PKEY_EC ) {
            RETVAL="ec";
#endif
        }

#line 1368 "X509.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509_num_extensions); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509_num_extensions)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x509");
    {
	Crypt__OpenSSL__X509	x509;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::num_extensions",
			"x509", "Crypt::OpenSSL::X509")
;
#line 961 "X509.xs"
  RETVAL = X509_get_ext_count(x509);

#line 1398 "X509.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509_extension); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509_extension)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "x509, i");
    {
	Crypt__OpenSSL__X509	x509;
	int	i = (int)SvIV(ST(1))
;
#line 972 "X509.xs"
  X509_EXTENSION *ext;
  int c;

#line 1419 "X509.c"
	Crypt__OpenSSL__X509__Extension	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::extension",
			"x509", "Crypt::OpenSSL::X509")
;
#line 976 "X509.xs"
  ext = NULL;

  c = X509_get_ext_count(x509);

  if (!(c > 0)) {
    croak("No extensions found\n");
  } else if (i >= c || i < 0) {
    croak("Requested extension index out of range\n");
  } else {
    ext = X509_get_ext(x509, i);
  }

  if (ext == NULL) {
    // X509_EXTENSION_free(ext); // not needed?
    croak("Extension unavailable\n");
  }

  RETVAL = ext;

#line 1451 "X509.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::OpenSSL::X509::Extension", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509_extensions); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509_extensions)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "x509");
    {
	Crypt__OpenSSL__X509	x509;
	HV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"x509", "Crypt::OpenSSL::X509")
;
#line 1008 "X509.xs"
  RETVAL = hv_exts(x509, ix);

#line 1486 "X509.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509__Extension_critical); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509__Extension_critical)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ext");
    {
	Crypt__OpenSSL__X509__Extension	ext;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Extension")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ext = INT2PTR(Crypt__OpenSSL__X509__Extension,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Extension::critical",
			"ext", "Crypt::OpenSSL::X509::Extension")
;
#line 1021 "X509.xs"
  if (ext == NULL) {
    croak("No extension supplied\n");
  }

  RETVAL = X509_EXTENSION_get_critical(ext);

#line 1525 "X509.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509__Extension_object); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509__Extension_object)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ext");
    {
	Crypt__OpenSSL__X509__Extension	ext;
	Crypt__OpenSSL__X509__ObjectID	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Extension")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ext = INT2PTR(Crypt__OpenSSL__X509__Extension,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Extension::object",
			"ext", "Crypt::OpenSSL::X509::Extension")
;
#line 1036 "X509.xs"
  if (ext == NULL) {
    croak("No extension supplied\n");
  }

  RETVAL = X509_EXTENSION_get_object(ext);

#line 1558 "X509.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::OpenSSL::X509::ObjectID", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509__Extension_value); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509__Extension_value)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ext");
    {
	Crypt__OpenSSL__X509__Extension	ext;
#line 1050 "X509.xs"
  BIO* bio;

#line 1581 "X509.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Extension")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ext = INT2PTR(Crypt__OpenSSL__X509__Extension,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Extension::value",
			"ext", "Crypt::OpenSSL::X509::Extension")
;
#line 1053 "X509.xs"
  bio  = sv_bio_create();

  if (ext == NULL) {
    BIO_free_all(bio);
    croak("No extension supplied\n");
  }

  ASN1_STRING_print_ex(bio, X509_EXTENSION_get_data(ext), ASN1_STRFLGS_DUMP_ALL);

  RETVAL = sv_bio_final(bio);

#line 1605 "X509.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509__Extension_to_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509__Extension_to_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ext");
    {
	Crypt__OpenSSL__X509__Extension	ext;
#line 1072 "X509.xs"
  BIO* bio;

#line 1624 "X509.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Extension")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ext = INT2PTR(Crypt__OpenSSL__X509__Extension,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Extension::to_string",
			"ext", "Crypt::OpenSSL::X509::Extension")
;
#line 1075 "X509.xs"
  bio = sv_bio_create();

  if (ext == NULL) {
    BIO_free_all(bio);
    croak("No extension supplied\n");
  }

  X509V3_EXT_print(bio, ext, 0, 0);

  RETVAL = sv_bio_final(bio);

#line 1648 "X509.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509__Extension_basicC); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509__Extension_basicC)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ext, value");
    {
	Crypt__OpenSSL__X509__Extension	ext;
	char *	value = (char *)SvPV_nolen(ST(1))
;
#line 1095 "X509.xs"
  BASIC_CONSTRAINTS *bs;
  int ret = 0;

#line 1670 "X509.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Extension")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ext = INT2PTR(Crypt__OpenSSL__X509__Extension,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Extension::basicC",
			"ext", "Crypt::OpenSSL::X509::Extension")
;
#line 1100 "X509.xs"
  /* retrieve the value of CA or pathlen in basicConstraints */
  bs = X509V3_EXT_d2i(ext);

  if (strcmp(value, "ca") == 0) {
    ret = bs->ca ? 1 : 0;

  } else if (strcmp(value, "pathlen") == 0) {
    ret = bs->pathlen ? 1 : 0;
  }

  BASIC_CONSTRAINTS_free(bs);

  RETVAL = ret;

#line 1698 "X509.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509__Extension_ia5string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509__Extension_ia5string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ext");
    {
	Crypt__OpenSSL__X509__Extension	ext;
#line 1122 "X509.xs"
  ASN1_IA5STRING *str;
  BIO *bio;

#line 1717 "X509.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Extension")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ext = INT2PTR(Crypt__OpenSSL__X509__Extension,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Extension::ia5string",
			"ext", "Crypt::OpenSSL::X509::Extension")
;
#line 1127 "X509.xs"
  /* retrieving the value of an ia5string object */
  bio = sv_bio_create();
  str = X509V3_EXT_d2i(ext);
  BIO_printf(bio,"%s", str->data);
  ASN1_IA5STRING_free(str);

  RETVAL = sv_bio_final(bio);

#line 1738 "X509.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509__Extension_bit_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509__Extension_bit_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ext");
    {
	Crypt__OpenSSL__X509__Extension	ext;
#line 1143 "X509.xs"
  int i, nid;
  ASN1_OBJECT *object;
  ASN1_BIT_STRING *bit_str;
  int string[10];
  BIO *bio;

#line 1761 "X509.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Extension")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ext = INT2PTR(Crypt__OpenSSL__X509__Extension,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Extension::bit_string",
			"ext", "Crypt::OpenSSL::X509::Extension")
;
#line 1150 "X509.xs"
  bio = sv_bio_create();

  object = X509_EXTENSION_get_object(ext);
  nid = OBJ_obj2nid(object);
  bit_str = X509V3_EXT_d2i(ext);

  if (nid == NID_key_usage) {

    for (i = 0; i < 9; i++) {
      string[i] = (int)ASN1_BIT_STRING_get_bit(bit_str, i);
      BIO_printf(bio, "%d", string[i]);
    }

  } else if (nid == NID_netscape_cert_type) {

    for (i = 0; i < 8; i++) {
      string[i] = (int)ASN1_BIT_STRING_get_bit(bit_str, i);
      BIO_printf(bio, "%d",  string[i]);
    }
  }

  RETVAL = sv_bio_final(bio);

#line 1797 "X509.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509__Extension_extendedKeyUsage); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509__Extension_extendedKeyUsage)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ext");
    {
	Crypt__OpenSSL__X509__Extension	ext;
#line 1181 "X509.xs"
  BIO *bio;
  STACK_OF(ASN1_OBJECT) *extku;
  int nid;
  const char *value;

#line 1819 "X509.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Extension")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ext = INT2PTR(Crypt__OpenSSL__X509__Extension,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Extension::extendedKeyUsage",
			"ext", "Crypt::OpenSSL::X509::Extension")
;
#line 1188 "X509.xs"
  bio   = sv_bio_create();
  extku = (STACK_OF(ASN1_OBJECT)*) X509V3_EXT_d2i(ext);

  while(sk_ASN1_OBJECT_num(extku) > 0) {
    nid = OBJ_obj2nid(sk_ASN1_OBJECT_pop(extku));
    value = OBJ_nid2sn(nid);
    BIO_printf(bio, "%s", value);
    BIO_printf(bio, " ");
  }

  RETVAL = sv_bio_final(bio);

#line 1844 "X509.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509__Extension_auth_att); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509__Extension_auth_att)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ext");
    {
	Crypt__OpenSSL__X509__Extension	ext;
#line 1208 "X509.xs"
  AUTHORITY_KEYID *akid;

#line 1863 "X509.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Extension")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ext = INT2PTR(Crypt__OpenSSL__X509__Extension,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Extension::auth_att",
			"ext", "Crypt::OpenSSL::X509::Extension")
;
#line 1212 "X509.xs"
  akid   = X509V3_EXT_d2i(ext);
  RETVAL = akid->keyid ? 1 : 0;

#line 1880 "X509.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509__Extension_keyid_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509__Extension_keyid_data)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ext");
    {
	Crypt__OpenSSL__X509__Extension	ext;
#line 1223 "X509.xs"
  AUTHORITY_KEYID *akid;
  ASN1_OCTET_STRING *skid;
  int nid;
  ASN1_OBJECT *object;
  BIO *bio;

#line 1902 "X509.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Extension")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ext = INT2PTR(Crypt__OpenSSL__X509__Extension,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Extension::keyid_data",
			"ext", "Crypt::OpenSSL::X509::Extension")
;
#line 1231 "X509.xs"
  bio    = sv_bio_create();
  object = X509_EXTENSION_get_object(ext);
  nid    = OBJ_obj2nid(object);

  if (nid == NID_authority_key_identifier) {

    akid = X509V3_EXT_d2i(ext);
    BIO_printf(bio, "%s", akid->keyid->data);

  } else if (nid == NID_subject_key_identifier) {

    skid = X509V3_EXT_d2i(ext);
    BIO_printf(bio, "%s", skid->data);
  }

  RETVAL = sv_bio_final(bio);

#line 1932 "X509.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509__ObjectID_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509__ObjectID_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	Crypt__OpenSSL__X509__ObjectID	obj;
#line 1257 "X509.xs"
  char buf[128];

#line 1951 "X509.c"
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509::ObjectID")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    obj = INT2PTR(Crypt__OpenSSL__X509__ObjectID,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::ObjectID::name",
			"obj", "Crypt::OpenSSL::X509::ObjectID")
;
#line 1261 "X509.xs"
  if (obj == NULL) {
    croak("No ObjectID supplied\n");
  }

  (void)OBJ_obj2txt(buf, 128, obj, 0);

  RETVAL = buf;

#line 1973 "X509.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509__ObjectID_oid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509__ObjectID_oid)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	Crypt__OpenSSL__X509__ObjectID	obj;
#line 1277 "X509.xs"
  char buf[128];

#line 1991 "X509.c"
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509::ObjectID")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    obj = INT2PTR(Crypt__OpenSSL__X509__ObjectID,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::ObjectID::oid",
			"obj", "Crypt::OpenSSL::X509::ObjectID")
;
#line 1281 "X509.xs"
  if (obj == NULL) {
    croak("No ObjectID supplied\n");
  }

  (void)OBJ_obj2txt(buf, 128, obj, 1);

  RETVAL = buf;

#line 2013 "X509.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509__Name_as_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509__Name_as_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "name");
    {
	Crypt__OpenSSL__X509__Name	name;
#line 1299 "X509.xs"
  BIO *bio;

#line 2031 "X509.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Name")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    name = INT2PTR(Crypt__OpenSSL__X509__Name,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Name::as_string",
			"name", "Crypt::OpenSSL::X509::Name")
;
#line 1303 "X509.xs"
  bio = sv_bio_create();
  /* this is prefered over X509_NAME_oneline() */
  X509_NAME_print_ex(bio, name, 0, XN_FLAG_SEP_CPLUS_SPC);

  RETVAL = sv_bio_final(bio);

#line 2050 "X509.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509__Name_entries); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509__Name_entries)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "name");
    {
	Crypt__OpenSSL__X509__Name	name;
#line 1317 "X509.xs"
  int i, c;
  SV* rv;

#line 2070 "X509.c"
	AV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Name")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    name = INT2PTR(Crypt__OpenSSL__X509__Name,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Name::entries",
			"name", "Crypt::OpenSSL::X509::Name")
;
#line 1322 "X509.xs"
  RETVAL = newAV();
  sv_2mortal((SV*)RETVAL);

  c = X509_NAME_entry_count(name);

  for (i = 0; i < c; i++) {
    rv = sv_make_ref("Crypt::OpenSSL::X509::Name_Entry", (void*)X509_NAME_get_entry(name, i));
    av_push(RETVAL, rv);
  }

#line 2093 "X509.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509__Name_get_index_by_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509__Name_get_index_by_type)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "name, type, lastpos = -1");
    {
	Crypt__OpenSSL__X509__Name	name;
	const char*	type = (const char *)SvPV_nolen(ST(1))
;
	int	lastpos;
#line 1349 "X509.xs"
  int nid, i;

#line 2120 "X509.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Name")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    name = INT2PTR(Crypt__OpenSSL__X509__Name,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"name", "Crypt::OpenSSL::X509::Name")
;

	if (items < 3)
	    lastpos = -1;
	else {
	    lastpos = (int)SvIV(ST(2))
;
	}
#line 1353 "X509.xs"
  if (ix == 1 || ix == 3) {
    nid = OBJ_ln2nid(type);
  } else if (ix == 4 || ix == 5) {
    nid = OBJ_obj2nid(OBJ_txt2obj(type, /*oid*/ 1));
  } else {
    nid = OBJ_sn2nid(type);
  }

  if (!nid) {
    croak("Unknown type");
  }

  i = X509_NAME_get_index_by_NID(name, nid, lastpos);

  if (ix == 2 || ix == 3 || ix == 4) { /* has_entry */
    RETVAL = (i > lastpos)?1:0;
  } else { /* get_index */
    RETVAL = i;
  }

#line 2161 "X509.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509__Name_get_entry_by_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509__Name_get_entry_by_type)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "name, type, lastpos = -1");
    {
	Crypt__OpenSSL__X509__Name	name;
	const char*	type = (const char *)SvPV_nolen(ST(1))
;
	int	lastpos;
#line 1386 "X509.xs"
  int nid, i;

#line 2183 "X509.c"
	Crypt__OpenSSL__X509__Name_Entry	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Name")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    name = INT2PTR(Crypt__OpenSSL__X509__Name,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"name", "Crypt::OpenSSL::X509::Name")
;

	if (items < 3)
	    lastpos = -1;
	else {
	    lastpos = (int)SvIV(ST(2))
;
	}
#line 1390 "X509.xs"
  if (ix == 1) {
    nid = OBJ_ln2nid(type);
  } else {
    nid = OBJ_sn2nid(type);
  }

  if (!nid) {
    croak("Unknown type");
  }

  i = X509_NAME_get_index_by_NID(name, nid, lastpos);
  RETVAL = X509_NAME_get_entry(name, i);

#line 2216 "X509.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::OpenSSL::X509::Name_Entry", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509__Name_Entry_as_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509__Name_Entry_as_string)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "name_entry, ln = 0");
    {
	Crypt__OpenSSL__X509__Name_Entry	name_entry;
	int	ln;
#line 1418 "X509.xs"
  BIO *bio;
  const char *n;
  int nid;

#line 2243 "X509.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Name_Entry")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    name_entry = INT2PTR(Crypt__OpenSSL__X509__Name_Entry,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"name_entry", "Crypt::OpenSSL::X509::Name_Entry")
;

	if (items < 2)
	    ln = 0;
	else {
	    ln = (int)SvIV(ST(1))
;
	}
#line 1423 "X509.xs"
  bio = sv_bio_create();
  nid = OBJ_obj2nid(X509_NAME_ENTRY_get_object(name_entry));

  if (ix == 1 || ln) {
    n = OBJ_nid2ln(nid);
  } else {
    n = OBJ_nid2sn(nid);
  }

  BIO_printf(bio, "%s=", n);

  ASN1_STRING_print_ex(bio, X509_NAME_ENTRY_get_data(name_entry), ASN1_STRFLGS_UTF8_CONVERT & ~ASN1_STRFLGS_ESC_MSB);

  sv_bio_utf8_on(bio);

  RETVAL = sv_bio_final(bio);

#line 2280 "X509.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509__Name_Entry_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509__Name_Entry_type)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "name_entry, ln = 0");
    {
	Crypt__OpenSSL__X509__Name_Entry	name_entry;
	int	ln;
#line 1452 "X509.xs"
  BIO *bio;
  const char *n;
  int nid;

#line 2303 "X509.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Name_Entry")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    name_entry = INT2PTR(Crypt__OpenSSL__X509__Name_Entry,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"name_entry", "Crypt::OpenSSL::X509::Name_Entry")
;

	if (items < 2)
	    ln = 0;
	else {
	    ln = (int)SvIV(ST(1))
;
	}
#line 1457 "X509.xs"
  bio = sv_bio_create();
  nid = OBJ_obj2nid(X509_NAME_ENTRY_get_object(name_entry));

  if (ix == 1 || ln) {
    n = OBJ_nid2ln(nid);
  } else {
    n = OBJ_nid2sn(nid);
  }

  BIO_printf(bio, "%s", n);
  RETVAL = sv_bio_final(bio);

#line 2335 "X509.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509__Name_Entry_value); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509__Name_Entry_value)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "name_entry");
    {
	Crypt__OpenSSL__X509__Name_Entry	name_entry;
#line 1477 "X509.xs"
  BIO *bio;

#line 2354 "X509.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Name_Entry")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    name_entry = INT2PTR(Crypt__OpenSSL__X509__Name_Entry,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Name_Entry::value",
			"name_entry", "Crypt::OpenSSL::X509::Name_Entry")
;
#line 1480 "X509.xs"
  bio = sv_bio_create();
  ASN1_STRING_print(bio, X509_NAME_ENTRY_get_data(name_entry));
  RETVAL = sv_bio_final(bio);

#line 2371 "X509.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509__Name_Entry_is_printableString); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509__Name_Entry_is_printableString)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "name_entry, asn1_type =  V_ASN1_PRINTABLESTRING");
    {
	Crypt__OpenSSL__X509__Name_Entry	name_entry;
	int	asn1_type;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Name_Entry")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    name_entry = INT2PTR(Crypt__OpenSSL__X509__Name_Entry,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"name_entry", "Crypt::OpenSSL::X509::Name_Entry")
;

	if (items < 2)
	    asn1_type = V_ASN1_PRINTABLESTRING;
	else {
	    asn1_type = (int)SvIV(ST(1))
;
	}
#line 1499 "X509.xs"
  RETVAL = (X509_NAME_ENTRY_get_data(name_entry)->type == (ix == 1 ? asn1_type : ix));

#line 2411 "X509.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509__Name_Entry_encoding); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509__Name_Entry_encoding)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "name_entry");
    {
	Crypt__OpenSSL__X509__Name_Entry	name_entry;
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509::Name_Entry")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    name_entry = INT2PTR(Crypt__OpenSSL__X509__Name_Entry,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Crypt::OpenSSL::X509::Name_Entry::encoding",
			"name_entry", "Crypt::OpenSSL::X509::Name_Entry")
;
#line 1509 "X509.xs"
  RETVAL = NULL;

  if (X509_NAME_ENTRY_get_data(name_entry)->type == V_ASN1_PRINTABLESTRING) {
    RETVAL = "printableString";

  } else if(X509_NAME_ENTRY_get_data(name_entry)->type == V_ASN1_IA5STRING) {
    RETVAL = "ia5String";

  } else if(X509_NAME_ENTRY_get_data(name_entry)->type == V_ASN1_UTF8STRING) {
    RETVAL = "utf8String";
  }

#line 2451 "X509.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509_CRL_new_from_crl_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509_CRL_new_from_crl_string)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "class, string, format = FORMAT_PEM");
    {
	SV *	class = ST(0)
;
	SV *	string = ST(1)
;
	int	format;
#line 1536 "X509.xs"
  BIO *bio;
  STRLEN len;
  char *crl;

#line 2476 "X509.c"
	Crypt__OpenSSL__X509__CRL	RETVAL;

	if (items < 3)
	    format = FORMAT_PEM;
	else {
	    format = (int)SvIV(ST(2))
;
	}
#line 1542 "X509.xs"
  crl = SvPV(string, len);

  if (ix == 1) {
    bio = BIO_new_file(crl, "r");
  } else {
    bio = BIO_new_mem_buf(crl, len);
  }

  if (!bio) {
    croak("%s: Failed to create BIO", SvPV_nolen(class));
  }

  if (format == FORMAT_ASN1) {
    RETVAL = (X509_CRL*)d2i_X509_CRL_bio(bio, NULL);
  } else {
    RETVAL = (X509_CRL*)PEM_read_bio_X509_CRL(bio, NULL, NULL, NULL);
  }

  if (!RETVAL) {
    croak("%s: failed to read X509 certificate.", SvPV_nolen(class));
  }

  BIO_free(bio);

#line 2510 "X509.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Crypt::OpenSSL::X509::CRL", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__X509_CRL_CRL_accessor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__X509_CRL_CRL_accessor)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "crl");
    {
	Crypt__OpenSSL__X509__CRL	crl;
#line 1578 "X509.xs"
  BIO *bio;
  X509_NAME *name;

#line 2535 "X509.c"
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Crypt::OpenSSL::X509::CRL")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    crl = INT2PTR(Crypt__OpenSSL__X509__CRL,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"crl", "Crypt::OpenSSL::X509::CRL")
;
#line 1582 "X509.xs"
  bio = sv_bio_create();

  if (ix == 1) {
    name = X509_CRL_get_issuer(crl);
    sv_bio_utf8_on(bio);
    X509_NAME_print_ex(bio, name, 0, (XN_FLAG_SEP_CPLUS_SPC | ASN1_STRFLGS_UTF8_CONVERT) & ~ASN1_STRFLGS_ESC_MSB);
    RETVAL = sv_bio_final(bio);

  } else if (ix == 2) {
    const_ossl11 X509_ALGOR *palg;
    const_ossl11 ASN1_OBJECT *paobj;

    X509_CRL_get0_signature(crl, NULL, &palg);
    X509_ALGOR_get0(&paobj, NULL, NULL, palg);

    i2a_ASN1_OBJECT(bio, paobj);
  }

  RETVAL = sv_bio_final(bio);

#line 2568 "X509.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Crypt__OpenSSL__X509); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Crypt__OpenSSL__X509)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

    {
        CV * cv;

        newXS_deffile("Crypt::OpenSSL::X509::new", XS_Crypt__OpenSSL__X509_new);
        cv = newXS_deffile("Crypt::OpenSSL::X509::new_from_file", XS_Crypt__OpenSSL__X509_new_from_string);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Crypt::OpenSSL::X509::new_from_string", XS_Crypt__OpenSSL__X509_new_from_string);
        XSANY.any_i32 = 0;
        newXS_deffile("Crypt::OpenSSL::X509::DESTROY", XS_Crypt__OpenSSL__X509_DESTROY);
        newXS_deffile("Crypt::OpenSSL::X509::__X509_cleanup", XS_Crypt__OpenSSL__X509___X509_cleanup);
        cv = newXS_deffile("Crypt::OpenSSL::X509::accessor", XS_Crypt__OpenSSL__X509_accessor);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Crypt::OpenSSL::X509::email", XS_Crypt__OpenSSL__X509_accessor);
        XSANY.any_i32 = 7;
        cv = newXS_deffile("Crypt::OpenSSL::X509::hash", XS_Crypt__OpenSSL__X509_accessor);
        XSANY.any_i32 = 4;
        cv = newXS_deffile("Crypt::OpenSSL::X509::issuer", XS_Crypt__OpenSSL__X509_accessor);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("Crypt::OpenSSL::X509::issuer_hash", XS_Crypt__OpenSSL__X509_accessor);
        XSANY.any_i32 = 11;
        cv = newXS_deffile("Crypt::OpenSSL::X509::key_alg_name", XS_Crypt__OpenSSL__X509_accessor);
        XSANY.any_i32 = 10;
        cv = newXS_deffile("Crypt::OpenSSL::X509::notAfter", XS_Crypt__OpenSSL__X509_accessor);
        XSANY.any_i32 = 6;
        cv = newXS_deffile("Crypt::OpenSSL::X509::notBefore", XS_Crypt__OpenSSL__X509_accessor);
        XSANY.any_i32 = 5;
        cv = newXS_deffile("Crypt::OpenSSL::X509::serial", XS_Crypt__OpenSSL__X509_accessor);
        XSANY.any_i32 = 3;
        cv = newXS_deffile("Crypt::OpenSSL::X509::sig_alg_name", XS_Crypt__OpenSSL__X509_accessor);
        XSANY.any_i32 = 9;
        cv = newXS_deffile("Crypt::OpenSSL::X509::subject", XS_Crypt__OpenSSL__X509_accessor);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Crypt::OpenSSL::X509::subject_hash", XS_Crypt__OpenSSL__X509_accessor);
        XSANY.any_i32 = 4;
        cv = newXS_deffile("Crypt::OpenSSL::X509::version", XS_Crypt__OpenSSL__X509_accessor);
        XSANY.any_i32 = 8;
        cv = newXS_deffile("Crypt::OpenSSL::X509::issuer_name", XS_Crypt__OpenSSL__X509_subject_name);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("Crypt::OpenSSL::X509::subject_name", XS_Crypt__OpenSSL__X509_subject_name);
        XSANY.any_i32 = 1;
        newXS_deffile("Crypt::OpenSSL::X509::sig_print", XS_Crypt__OpenSSL__X509_sig_print);
        newXS_deffile("Crypt::OpenSSL::X509::as_string", XS_Crypt__OpenSSL__X509_as_string);
        newXS_deffile("Crypt::OpenSSL::X509::bit_length", XS_Crypt__OpenSSL__X509_bit_length);
        newXS_deffile("Crypt::OpenSSL::X509::curve", XS_Crypt__OpenSSL__X509_curve);
        newXS_deffile("Crypt::OpenSSL::X509::modulus", XS_Crypt__OpenSSL__X509_modulus);
        cv = newXS_deffile("Crypt::OpenSSL::X509::exponent", XS_Crypt__OpenSSL__X509_exponent);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Crypt::OpenSSL::X509::pub_exponent", XS_Crypt__OpenSSL__X509_exponent);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Crypt::OpenSSL::X509::fingerprint_md5", XS_Crypt__OpenSSL__X509_fingerprint_md5);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Crypt::OpenSSL::X509::fingerprint_sha1", XS_Crypt__OpenSSL__X509_fingerprint_md5);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Crypt::OpenSSL::X509::fingerprint_sha224", XS_Crypt__OpenSSL__X509_fingerprint_md5);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("Crypt::OpenSSL::X509::fingerprint_sha256", XS_Crypt__OpenSSL__X509_fingerprint_md5);
        XSANY.any_i32 = 3;
        cv = newXS_deffile("Crypt::OpenSSL::X509::fingerprint_sha384", XS_Crypt__OpenSSL__X509_fingerprint_md5);
        XSANY.any_i32 = 4;
        cv = newXS_deffile("Crypt::OpenSSL::X509::fingerprint_sha512", XS_Crypt__OpenSSL__X509_fingerprint_md5);
        XSANY.any_i32 = 5;
        newXS_deffile("Crypt::OpenSSL::X509::checkend", XS_Crypt__OpenSSL__X509_checkend);
        newXS_deffile("Crypt::OpenSSL::X509::pubkey", XS_Crypt__OpenSSL__X509_pubkey);
        newXS_deffile("Crypt::OpenSSL::X509::pubkey_type", XS_Crypt__OpenSSL__X509_pubkey_type);
        newXS_deffile("Crypt::OpenSSL::X509::num_extensions", XS_Crypt__OpenSSL__X509_num_extensions);
        newXS_deffile("Crypt::OpenSSL::X509::extension", XS_Crypt__OpenSSL__X509_extension);
        cv = newXS_deffile("Crypt::OpenSSL::X509::extensions", XS_Crypt__OpenSSL__X509_extensions);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Crypt::OpenSSL::X509::extensions_by_long_name", XS_Crypt__OpenSSL__X509_extensions);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Crypt::OpenSSL::X509::extensions_by_name", XS_Crypt__OpenSSL__X509_extensions);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("Crypt::OpenSSL::X509::extensions_by_oid", XS_Crypt__OpenSSL__X509_extensions);
        XSANY.any_i32 = 1;
        newXS_deffile("Crypt::OpenSSL::X509::Extension::critical", XS_Crypt__OpenSSL__X509__Extension_critical);
        newXS_deffile("Crypt::OpenSSL::X509::Extension::object", XS_Crypt__OpenSSL__X509__Extension_object);
        newXS_deffile("Crypt::OpenSSL::X509::Extension::value", XS_Crypt__OpenSSL__X509__Extension_value);
        newXS_deffile("Crypt::OpenSSL::X509::Extension::to_string", XS_Crypt__OpenSSL__X509__Extension_to_string);
        newXS_deffile("Crypt::OpenSSL::X509::Extension::basicC", XS_Crypt__OpenSSL__X509__Extension_basicC);
        newXS_deffile("Crypt::OpenSSL::X509::Extension::ia5string", XS_Crypt__OpenSSL__X509__Extension_ia5string);
        newXS_deffile("Crypt::OpenSSL::X509::Extension::bit_string", XS_Crypt__OpenSSL__X509__Extension_bit_string);
        newXS_deffile("Crypt::OpenSSL::X509::Extension::extendedKeyUsage", XS_Crypt__OpenSSL__X509__Extension_extendedKeyUsage);
        newXS_deffile("Crypt::OpenSSL::X509::Extension::auth_att", XS_Crypt__OpenSSL__X509__Extension_auth_att);
        newXS_deffile("Crypt::OpenSSL::X509::Extension::keyid_data", XS_Crypt__OpenSSL__X509__Extension_keyid_data);
        newXS_deffile("Crypt::OpenSSL::X509::ObjectID::name", XS_Crypt__OpenSSL__X509__ObjectID_name);
        newXS_deffile("Crypt::OpenSSL::X509::ObjectID::oid", XS_Crypt__OpenSSL__X509__ObjectID_oid);
        newXS_deffile("Crypt::OpenSSL::X509::Name::as_string", XS_Crypt__OpenSSL__X509__Name_as_string);
        newXS_deffile("Crypt::OpenSSL::X509::Name::entries", XS_Crypt__OpenSSL__X509__Name_entries);
        cv = newXS_deffile("Crypt::OpenSSL::X509::Name::get_index_by_long_type", XS_Crypt__OpenSSL__X509__Name_get_index_by_type);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Crypt::OpenSSL::X509::Name::get_index_by_oid_type", XS_Crypt__OpenSSL__X509__Name_get_index_by_type);
        XSANY.any_i32 = 5;
        cv = newXS_deffile("Crypt::OpenSSL::X509::Name::get_index_by_type", XS_Crypt__OpenSSL__X509__Name_get_index_by_type);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Crypt::OpenSSL::X509::Name::has_entry", XS_Crypt__OpenSSL__X509__Name_get_index_by_type);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("Crypt::OpenSSL::X509::Name::has_long_entry", XS_Crypt__OpenSSL__X509__Name_get_index_by_type);
        XSANY.any_i32 = 3;
        cv = newXS_deffile("Crypt::OpenSSL::X509::Name::has_oid_entry", XS_Crypt__OpenSSL__X509__Name_get_index_by_type);
        XSANY.any_i32 = 4;
        cv = newXS_deffile("Crypt::OpenSSL::X509::Name::get_entry_by_long_type", XS_Crypt__OpenSSL__X509__Name_get_entry_by_type);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Crypt::OpenSSL::X509::Name::get_entry_by_type", XS_Crypt__OpenSSL__X509__Name_get_entry_by_type);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Crypt::OpenSSL::X509::Name_Entry::as_long_string", XS_Crypt__OpenSSL__X509__Name_Entry_as_string);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Crypt::OpenSSL::X509::Name_Entry::as_string", XS_Crypt__OpenSSL__X509__Name_Entry_as_string);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Crypt::OpenSSL::X509::Name_Entry::long_type", XS_Crypt__OpenSSL__X509__Name_Entry_type);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Crypt::OpenSSL::X509::Name_Entry::type", XS_Crypt__OpenSSL__X509__Name_Entry_type);
        XSANY.any_i32 = 0;
        newXS_deffile("Crypt::OpenSSL::X509::Name_Entry::value", XS_Crypt__OpenSSL__X509__Name_Entry_value);
        cv = newXS_deffile("Crypt::OpenSSL::X509::Name_Entry::is_asn1_type", XS_Crypt__OpenSSL__X509__Name_Entry_is_printableString);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Crypt::OpenSSL::X509::Name_Entry::is_ia5string", XS_Crypt__OpenSSL__X509__Name_Entry_is_printableString);
        XSANY.any_i32 = V_ASN1_IA5STRING;
        cv = newXS_deffile("Crypt::OpenSSL::X509::Name_Entry::is_printableString", XS_Crypt__OpenSSL__X509__Name_Entry_is_printableString);
        XSANY.any_i32 = V_ASN1_PRINTABLESTRING;
        cv = newXS_deffile("Crypt::OpenSSL::X509::Name_Entry::is_utf8string", XS_Crypt__OpenSSL__X509__Name_Entry_is_printableString);
        XSANY.any_i32 = V_ASN1_UTF8STRING;
        newXS_deffile("Crypt::OpenSSL::X509::Name_Entry::encoding", XS_Crypt__OpenSSL__X509__Name_Entry_encoding);
        cv = newXS_deffile("Crypt::OpenSSL::X509_CRL::new_from_crl_file", XS_Crypt__OpenSSL__X509_CRL_new_from_crl_string);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Crypt::OpenSSL::X509_CRL::new_from_crl_string", XS_Crypt__OpenSSL__X509_CRL_new_from_crl_string);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Crypt::OpenSSL::X509_CRL::CRL_accessor", XS_Crypt__OpenSSL__X509_CRL_CRL_accessor);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Crypt::OpenSSL::X509_CRL::CRL_issuer", XS_Crypt__OpenSSL__X509_CRL_CRL_accessor);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Crypt::OpenSSL::X509_CRL::CRL_sig_alg_name", XS_Crypt__OpenSSL__X509_CRL_CRL_accessor);
        XSANY.any_i32 = 2;
    }

    /* Initialisation Section */

#line 300 "X509.xs"
{
  HV *stash = gv_stashpvn("Crypt::OpenSSL::X509", 20, TRUE);

  struct { char *n; I32 v; } Crypt__OpenSSL__X509__const[] = {

  {"OPENSSL_VERSION_NUMBER", OPENSSL_VERSION_NUMBER},
  {"FORMAT_UNDEF", FORMAT_UNDEF},
  {"FORMAT_ASN1", FORMAT_ASN1},
  {"FORMAT_TEXT", FORMAT_TEXT},
  {"FORMAT_PEM", FORMAT_PEM},
  {"FORMAT_PKCS12", FORMAT_PKCS12},
  {"FORMAT_SMIME", FORMAT_SMIME},
  {"FORMAT_ENGINE", FORMAT_ENGINE},
  {"FORMAT_IISSGC", FORMAT_IISSGC},
  {"V_ASN1_PRINTABLESTRING",  V_ASN1_PRINTABLESTRING},
  {"V_ASN1_UTF8STRING",  V_ASN1_UTF8STRING},
  {"V_ASN1_IA5STRING",  V_ASN1_IA5STRING},
  {Nullch,0}};

  char *name;
  int i;

  for (i = 0; (name = Crypt__OpenSSL__X509__const[i].n); i++) {
    newCONSTSUB(stash, name, newSViv(Crypt__OpenSSL__X509__const[i].v));
  }

  ERR_load_crypto_strings();
  OPENSSL_add_all_algorithms_conf();
}

#line 2770 "X509.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

